import math

class polygon:
    """Represents a regular polygon of arbitrary number of edges and color. """

    def __init__(self, ed, color = "none", length = 1):
        self.edges = ed # we could also define these above as variables
        self.color = color
	self.length = length

    def __str__(self):
	return  "A " + self.color + " polygon with " + str(self.edges) + \
               " edges of length " + str(self.length)

    def angles(self): #in radians
        return ((self.edges - 2)*math.pi)/(self.edges)

    def area(self):
        return (self.edges*self.length**2)/(4*math.tan(math.pi/self.edges))

    def paint(self, newColor):
        self.color = newColor

    def multArea(self, n):
        """Create a new polygon with a multiple of the area of the old one. """
        newArea = self.area() * n
        oldEdges = self.edges
	oldColor = self.color
        newLength = math.sqrt((newArea*4*math.tan(math.pi/oldEdges))/oldEdges)
        return polygon(oldEdges, oldColor, length = newLength)



class box:
    def __init__(self):
	# boxes always start empty
	self.contents = []

    def __str__(self):
	return "This is a box of " + str(len(self.contents)) + " polygons."

    def listContents(self):
	print "This box contains:"
	for p in self.contents:
            #note - this calls the __str__ function for the polygon
	    print p

    def putin(self, item):
	"""Can put in either a single polygon or another box of polygons."""
	if isinstance(item, box):
	    for p in item.contents:
		self.contents[:0] = [p] # inserts at the beginning of the list
	elif isinstance(item, polygon):
	    self.contents[:0] = [item] # inserts at the beginning of the list
	else:
	    print "This box is only for polygons."

    def takeout(self, edges = 0, color = "", area = 0):
	"""Take out all polygons that meet any specified criteria."""
	if edges == 0 and color == "" and area == 0:
	    print "Please remember to specify what kind of polygons you want to take out."
	else:
	    noDel = True
	    newContents = []
	    for p in self.contents:
		if edges == p.edges or color == p.color or area == int(p.area()):
		    noDel = False
		else:
                    newContents.append(p) # could also write newContents[len(newContents):] = [p]
	    if noDel:
		print "No polygons in this box matched your criteria for deletion."
	    else:
		self.contents = newContents

    def howMany(self, edges = 0, color = ""):
	count = 0
	if edges == 0 and color == "":
	    print "Please specify what you want to count."
	elif edges != 0 and color != "":
	    print "Please be more specific about what you want to count."
	else:
	    for p in self.contents:
		if edges == p.edges or color == p.color:
		    count = count + 1
	    if count == 0:
		print "No polygons in this box matched your criteria."
	    else:
		return count

    def paint(self, newColor):
	"""Paint every polygon in the box a new color."""
	for p in self.contents:
	    p.paint(newColor)

if True:

#INSTANTIATION (making INSTANCES of a CLASS)
    blueTriangle = polygon(3, length = 3, color="blue")#order doesn't matter for optionals
    yellowSquare = polygon(4, "yellow", 2) #however, u don't need names if in order
    redPentagon = polygon(5, "red")#don't need to specify all if in order

#METHODS - self
#self in a param list basically says:
#"this is a method that can act upon an instance of this class" 
#(aka - use the dotted method notation) 
#you don't pass in self as an argument, but it must be in the param list in order 
#for the dotted method notation to work

#CALLING A METHOD ON AN OBJECT - DOTTED METHOD NOTATION
#even though no params - still need parens - that makes it a function
    yellowSquare.area()

#STR
#why might you want a string representation of your class? 
#in debugging if you wanted to print it out, but didn't feel like printing messages 
#each time
    print yellowSquare

#create a new square, twice the size of the yellow one, and paint it orange
    newSquare = yellowSquare.multArea(2)
    newSquare.area()
    yellowSquare.area()#the yellowsquare's size didn't change because multArea 
#					returned a new instance of the polygon class
    newSquare.paint("orange")
    print yellowSquare
    print newSquare

#COPY
    import copy # used for copying objects
    ys = copy.copy(yellowSquare) # creates a shallow copy which is fine for us.  use copy.deepcopy for a deep copy
    yellowSquare.length = 20
    print ys
    print yellowSquare

#classes interacting with each other
    aBox = box()
    aBox.putin(newSquare)
    aBox.putin(yellowSquare)
    aBox.putin(blueTriangle)
    aBox.putin(redPentagon)
    print
    print aBox

#point out LISTCONTENTS - called print polygon - str fun
    aBox.listContents()

#you can do things to the polygons when they're inside the box
    print
    print "Painting everything blue"
    aBox.paint("blue")
    aBox.listContents()

#takeout all blue things
    print
    aBox.takeout()
    print "Nothing should have changed"

    aBox.listContents()
    print 
    print "Removing everything blue"
    aBox.takeout(color = "blue")
    print
    print "Removed all the blue, so should be empty"
    print aBox

#put everything back in the box
    print 
    aBox.putin(newSquare)
    aBox.putin(yellowSquare)
    aBox.putin(blueTriangle)
    aBox.listContents()

    print 
    print "Changing to red..."
    blueTriangle.paint("red") #polygons can be modified in the box since its a reference!
    aBox.listContents()

    print 
    print "Removing the red"
    aBox.takeout(area = 4, color = "red")
    print str(aBox)
